%global momorel 1
%global udevrulesdir %{udevdir}/rules.d
%global udevdir %{_prefix}/lib/udev
%global udevhwdbdir %{udevdir}/hwdb.d
%global _maindocdir %{_docdir}/%{name}
%global _docdocdir %{_docdir}/%{name}-doc

Summary: Scanner access software
Name: sane-backends
Version: 1.0.27
Release: %{momorel}m%{?dist}
License: GPLv2+ and "LGPLv2+ with exceptions" and Public Domain
Group: System Environment/Libraries
URL: http://www.sane-project.org/
Source0: https://alioth.debian.org/frs/download.php/file/4224/%{name}-%{version}.tar.gz
NoSource: 0
Source1: sane.png
Source2: saned.socket
Source3: saned.service.in

Patch0: sane-backends-1.0.25-udev.patch
Patch1: sane-backends-1.0.23-soname.patch
Patch2: sane-backends-1.0.23-sane-config-multilib.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: %{name}-libs = %{version}-%{release}
Requires: coreutils
Requires: pam
Requires: udev
BuildRequires: gettext
BuildRequires: libgphoto2-devel >= 2.5.0
BuildRequires: libieee1284-devel
BuildRequires: libjpeg-devel >= 8a
BuildRequires: libtiff-devel >= 4.0.1
BuildRequires: libusb-devel >= 0.1.6
BuildRequires: pkgconfig
BuildRequires: tetex-latex
BuildRequires: net-snmp >= 5.7.1

%description
Scanner Access Now Easy (SANE) is a universal scanner interface.  The
SANE application programming interface (API) provides standardized
access to any raster image scanner hardware (flatbed scanner,
hand-held scanner, video and still cameras, frame-grabbers, etc.). If
they're using SANE, developers can write image-processing applications
without having to think about the peculiarities of individual devices.
SANE also makes it possible to write a device driver once, which can
then be used by any SANE-compliant application. SANE currently
includes drivers for some Epson SCSI scanners, HP ScanJet SCSI
scanners, Microtek SCSI scanners, Mustek SCSI flatbed scanners, PINT
devices, most UMAX SCSI scanners, Connectix QuickCam, and other SANE
devices via network. Note that this package does not enable network
scanning by default.  If you wish to enable network scanning, read the
saned(1) manpage.  If you'd like to develop SANE modules, you should
also install the sane-backends-devel package.

%package libs
Summary: SANE libraries
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description libs
This package contains the SANE libraries which are needed by applications that
want to access scanners.

%package devel
Summary: The SANE (a universal scanner interface) development toolkit
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig
Obsoletes: sane-devel
Provides: sane-devel

%description devel
Static libraries and header files for writing Scanner Access Now Easy
(SANE) modules.  SANE is a universal scanner interface which is
included in the sane-backends package.

%package daemon
Summary: Scanner network daemon
Requires: sane-backends = %{?epoch:%{epoch}:}%{version}-%{release}
Requires: sane-backends-libs%{?_isa} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires(pre): shadow-utils

%description daemon
This package contains saned which is the daemon that allows remote clients to
access image acquisition devices available on the local host.

%prep
%setup -q

%patch0 -p1 -b .udev
%patch1 -p1 -b .soname
%patch2 -p1 -b .sane-config-multilib

%build
CFLAGS="%optflags -fno-strict-aliasing"
CFLAGS="$CFLAGS -fPIC"
LDFLAGS="-pie"
%configure \
    --with-gphoto2=%{_prefix} \
    --with-docdir=%{_maindocdir} \
    --with-systemd \
    --disable-locking --disable-rpath \
    --enable-libusb_1_0 \
    --enable-pthread
make %{?_smp_mflags}

# Write udev/hwdb files
_topdir="$PWD"
pushd tools
./sane-desc -m udev+hwdb -s "${_topdir}/doc/descriptions:${_topdir}/doc/descriptions-external" -d0 > udev/sane-backends.rules
./sane-desc -m hwdb -s "${_topdir}/doc/descriptions:${_topdir}/doc/descriptions-external" -d0 > udev/sane-backends.hwdb

popd

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
make DESTDIR="%{buildroot}" install

mkdir -p %{buildroot}%{_datadir}/pixmaps
install -m 644 %{SOURCE1} %{buildroot}%{_datadir}/pixmaps
rm -f %{buildroot}%{_bindir}/gamma4scanimage
rm -f %{buildroot}%{_mandir}/man1/gamma4scanimage.1*
rm -f %{buildroot}%{_libdir}/sane/*.a %{buildroot}%{_libdir}/*.a
rm -f %{buildroot}%{_libdir}/libsane*.la %{buildroot}%{_libdir}/sane/*.la

mkdir -p %{buildroot}%{udevrulesdir}
mkdir -p %{buildroot}%{udevhwdbdir}
install -m 0644 tools/udev/sane-backends.rules %{buildroot}%{udevrulesdir}/65-sane-backends.rules
install -m 0644 tools/udev/sane-backends.hwdb %{buildroot}%{udevhwdbdir}/20-sane-backends.hwdb

mkdir -p %{buildroot}%{_libdir}/pkgconfig
install -m 0644 tools/sane-backends.pc %{buildroot}%{_libdir}/pkgconfig/

mkdir %{buildroot}%{_docdocdir}
pushd %{buildroot}%{_maindocdir}
for f in *; do
    if [ -d "$f" ]; then
        mv "$f" "%{buildroot}%{_docdocdir}/${f}"
    else
        case "$f" in
        AUTHORS|ChangeLog|COPYING|LICENSE|NEWS|PROBLEMS|README|README.linux)
            ;;
        backend-writing.txt|PROJECTS|sane-*.html)
            mv "$f" "%{buildroot}%{_docdocdir}/${f}"
            ;;
        *)
            rm -rf "$f"
            ;;
        esac
    fi
done
popd

install -m 755 -d %{buildroot}%{_unitdir}
install -m 644 %{SOURCE2} %{buildroot}%{_unitdir}
sed 's|@CONFIGDIR@|%{_sysconfdir}/sane.d|g' < %{SOURCE3} > saned@.service
install -m 644 saned@.service %{buildroot}%{_unitdir}

%find_lang %name

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post
udevadm hwdb --update >/dev/null 2>&1 || :

%postun
udevadm hwdb --update >/dev/null 2>&1 || :

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%pre daemon
getent group saned >/dev/null || groupadd -r saned
getent passwd saned >/dev/null || \
    useradd -r -g saned -d %{_datadir}/sane -s /sbin/nologin \
                -c "SANE scanner daemon user" saned
exit 0

%post daemon
%systemd_post saned.socket

%preun daemon
%systemd_preun saned.socket

%postun daemon
%systemd_postun saned.socket


%files -f %{name}.lang
%defattr(-,root,root)
%docdir %{_maindocdir}
%doc %{_maindocdir}/AUTHORS
%doc %{_maindocdir}/ChangeLog
%doc %{_maindocdir}/NEWS
%doc %{_maindocdir}/PROBLEMS
%doc %{_maindocdir}/README*
%dir /etc/sane.d
%dir /etc/sane.d/dll.d
%config(noreplace) /etc/sane.d/*.conf
%{udevrulesdir}/65-sane-backends.rules
%{udevhwdbdir}/20-sane-backends.hwdb
%{_datadir}/pixmaps/sane.png
%{_datadir}/doc/sane-backends/
%{_datadir}/doc/sane-backends-doc/

%{_bindir}/sane-find-scanner
%{_bindir}/scanimage
%{_bindir}/umax_pp

%exclude %{_mandir}/man1/sane-config.1*
%{_mandir}/*/*

%dir %{_libdir}/sane
%dir %{_datadir}/sane

%files libs
%defattr(-,root,root)
%{_libdir}/sane
%{_libdir}/libsane.so.*

%files devel
%defattr(-,root,root)
%{_bindir}/sane-config
%{_includedir}/sane
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/libsane.so
%{_mandir}/man1/sane-config.1*

%files daemon
%{_sbindir}/saned
%{_unitdir}/saned.socket
%{_unitdir}/saned@.service

%changelog
* Tue May 30 2017 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.27-1m)
- UPDATE 1.0.27

* Wed Nov 30 2016 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.25-1m)
- UPDATE 1.0.25

* Tue Aug 28 2012 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.22-6m)
- change Source0 URI

* Thu Aug 23 2012 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.22-5m)
- rebuild against libgphoto2-2.5.0

* Sun Apr  8 2012 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.22-4m)
- rebuild against libtiff-4.0.1

* Sat Oct 29 2011 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0.22-3m)
- rebuild against net-snmp-5.7.1

* Sun Jul 24 2011 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.0.22-2m)
- rebuild against net-snmp

* Tue Apr 12 2011 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.22-1m)
- version 1.0.22
- update patches
- import v4l.patch and SCX4500W.patch from Fedora
- remove i18n.patch and merged pkgconfig-0.25.patch

* Mon Apr 11 2011 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0.21-6m)
- rebuild for new GCC 4.6

* Sun Nov 28 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0.21-5m)
- rebuild for new GCC 4.5

* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.21-4m)
- full rebuild for mo7 release

* Wed Jul 14 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.21-3m)
- split package libs

* Sat Jun 19 2010 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.0.21-2m)
- add patch101 (for pkgconfig-0.25)

* Mon May 31 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.21-1m)
- version 1.0.21
- switch from using hal to using udev
- import 9 patches from F-13

* Sat Apr 10 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0.19-8m)
- rebuild against libjpeg-8a

* Mon Dec 28 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0.19-7m)
- delete __libtoolize hack

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0.19-6m)
- rebuild against gcc-4.4 and glibc-2.11

* Fri Sep 11 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (1.0.19-5m)
- rebuild against libjpeg-7

* Sun May 31 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.19-4m)
- fix build with new libtool
- remove acinclude.patch
- update rpath.patch from Fedora

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0.19-3m)
- rebuild against rpm-4.6

* Sun Jan 11 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.0.19-2m)
- update Patch3 for fuzz=0
- not Provides: libsane.so.1
- License: GPLv2+ and "LGPLv2+ with exceptions" and Public Domain

* Sun Jun 15 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.19-1m)
- version 1.0.19
- import 6 patches and a source from Fedora
- use hal and PolicyKit instead of udev
- sort %%files
- clean up spec file
- remove non-ascii character from %%changelog

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0.18-3m)
- rebuild against gcc43

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.18-2m)
- %%NoSource -> NoSource

* Fri May 25 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.18-1m)
- version 1.0.18

* Mon Feb 12 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.0.17-4m)
- delete libtool library

* Fri Aug 11 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.17-3m)
- Requires: udev

* Fri Aug 11 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.17-2m)
- add udev support
- remove hotplug support

* Sun Jun  4 2006 NARITA Koichi <pulsar@sea.plala.or.jp>
- (1.0.17-1m)
- update to 1.0.17
- change source URI

* Sat Dec 3 2005 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.0.15-2m)
- rebuild agenst libexif-0.6.12-1m

* Thu Jan 20 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0.15-1m)
- verup to 1.0.15

* Wed Jun  2 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.14-1m)
- verup

* Wed Apr  7 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (1.0.13-3m)
- add PreReq: coreutils

* Sat Mar 27 2004 Toru Hoshina <t@momonga-linux.org>
- (1.0.13-2m)
- revised spec for rpm 4.2.

* Sun Nov 30 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0.13-1m)
- update to 1.0.13
- update Source2 and NoSource
- delete %%doc doc/*.ps 
- delete %%doc TODO from files section

* Fri Oct 17 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.0.12-3m)
- update URL

* Mon Oct 13 2003 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.0.12-2m)
- adapt the License: preamble for the Momonga Linux license
  expression unification policy (draft)

* Tue Jul  8 2003 Kimitake Shibata <cipher@da2.so-net.ne.jp>
- (1.0.12-1m)
  Update to 1.0.12
  Since it was taken in, "epson" and "fujitsu" patch was deleted.

* Sat May  3 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.0.11-2m)
- import the patches from Mandrake.
  see the corresponding changelog below:

  * Sat Feb 15 2003 Till Kamppeter <till@mandrakesoft.com> 1.0.11-5mdk
  - Now the "epson" backend should alsoi accept unknown USB vendor/product
    IDs in "usb ..." lines in epson.conf.

  * Sat Feb 15 2003 Till Kamppeter <till@mandrakesoft.com> 1.0.11-4mdk
  - Really fixed bug that "epson" backend only accepted decimal USB
    vendor/product IDs.
  - Applied bug fix patch for the "avision" backend.

  * Fri Feb 14 2003 Till Kamppeter <till@mandrakesoft.com> 1.0.11-3mdk
  - Added support for USB scanners with the "fujitsu" backend, especially
    also for the Fujitsu fi-4220C.
  - Fixed documentation and config files of the "epson" backend to mention
    USB scanner auto-detection support.
  - Fixed bug that "epson" backend only accepted decimal USB vendor/product
    IDs.

  * Mon Feb 10 2003 Till Kamppeter <till@mandrakesoft.com> 1.0.11-2mdk
  - Updated "snapscan" backend (Support for Epson Perfection 660).

* Mon Feb 10 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.0.11-1m)
- [security]
  Since the SANE network scanning dameon (saned)
  in sane-backends-1.0.10 and all previous versions
  has remote DoS vulnerability, I upgraded it to the latest one (1.0.11).
  See the following for details.
  http://panda.mostang.com/pipermail/sane-devel/2003-February/017621.html

* Mon Feb 10 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (1.0.10-1m)
- update to 1.0.10
- move sane-config to -devel
- do not install doc/*.man
- fix BuildPrereq's

* Wed Dec 11 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (1.0.9-1m)
- update to 1.0.9
- add BuildPreReq: libusb >= 0.1.6
- add BuildPreReq: libgphoto2
- add BuildPreReq: libjpeg

* Wed Jul 24 2002 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.8-1m)
- version up 1.0.8

* Sat Mar 23 2002 Toru Hoshina <t@kondara.org>
- (1.0.7-4k)
- alpha... scanimage -f is not supported.

* Mon Feb 18 2002 Tsutomu Yasuda <tom@kondara.org>
- (1.0.7-2k)
- update to 1.0.7

* Fri Oct 25 2001 Toru Hoshina <t@kondara.org>
- (1.0.5-2k)
- merge from rawhide. [1.0.5-4]
- sane obsoleted.

* Fri Jul 20 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- exclude s390, s390x

* Tue Jul 17 2001 Preston Brown <pbrown@redhat.com> 1.0.5-3
- sane.png included

* Tue Jul 10 2001 Tim Waugh <twaugh@redhat.com> 1.0.5-2
- sane-backends-devel provides sane-devel.

* Sun Jul  1 2001 Tim Waugh <twaugh@redhat.com> 1.0.5-1
- 1.0.5.

* Wed Jun 20 2001 Tim Waugh <twaugh@redhat.com> 1.0.5-0.20010620.0
- 2001-06-20 CVS update.  PreReq /bin/cat, /bin/rm.

* Mon Jun 11 2001 Tim Waugh <twaugh@redhat.com> 1.0.5-0.20010610
- 2001-06-10 CVS snapshot.  umax_pp update from CVS again to fix more
  build problems.

* Sun Jun  3 2001 Tim Waugh <twaugh@redhat.com> 1.0.5-0.20010603.1000
- 2001-06-03 CVS snapshot (10:00).  Fixes umax_pp build problems.

* Sat Jun  2 2001 Tim Waugh <twaugh@redhat.com> 1.0.5-0.20010530
- sane-backends (sane-frontends is in a separate package now).
- 2001-05-30 CVS snapshot.
- include.patch no longer needed.
- sg3timeout.patch no longer needed.

* Mon Jan 22 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.0.3-10
- Fix up the libtool config file /usr/lib/libsane.la
  kscan should build now. ;)

* Wed Jan 10 2001 Tim Waugh <twaugh@redhat.com>
- Increase timeout for SCSI commands sent via sg driver version 3
  (bug #23447)

* Mon Dec 25 2000 Matt Wilson <msw@redhat.com>
- rebuilt against gimp 1.2.0

* Thu Dec 21 2000 Matt Wilson <msw@redhat.com>
- rebuilt against gimp 1.1.32
- use -DGIMP_ENABLE_COMPAT_CRUFT=1 to build with compat macros

* Mon Dec 18 2000 Matt Wilson <msw@redhat.com>
- rebuilt against gimp 1.1.30

* Fri Dec  1 2000 Tim Waugh <twaugh@redhat.com>
- Rebuild because of fileutils bug.

* Thu Oct 26 2000 Bill Nottingham <notting@redhat.com>
- fix provides for ia64/sparc64

* Thu Aug 29 2000 Trond Eivind Glomsrod <teg@redhat.com>
- don't include xscanimage desktop entry - it's a gimp
  plugin. Doh. (part of #17076)
- add tetex-latex as a build requirement

* Wed Aug 23 2000 Matt Wilson <msw@redhat.com>
- built against gimp 1.1.25

* Tue Aug 22 2000 Preston Brown <pbrown@redhat.com>
- 1.0.3 bugfix release (#16726)
- rev patch removed, no longer needed

* Tue Aug 15 2000 Than Ngo <than@redhat.com>
- add triggerpostun to fix removing path from ld.so.conf at update

* Fri Aug  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add Swedish and German translations to desktop file, Bug #15317

* Sun Jul 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- use mktemp in post and postun scripts
- fix incorrect usage of rev in backend/Makefile

* Wed Jul 19 2000 Trond Eivind Glomsrod <teg@redhat.com>
- workarounds for weird bug (all so-files had names with "s="
  - except for sparc which has just "=" and IA64 which works)

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jul  3 2000 Matt Wilson <msw@redhat.com>
- rebuilt against gimp-1.1.24

* Tue Jun 13 2000 Preston Brown <pbrown@redhat.com>
- FHS paths
- work around ICE on intel.  FIX ME!

* Mon May 22 2000 Tim Powers <timp@redhat.com>
-  rebuilt w/ glibc-2.1.90

* Thu May 18 2000 Tim Powers <timp@redhat.com>
- updated to 1.0.2

* Wed Jul 21 1999 Tim Powers <timp@redhat.com>
- rebuilt for 6.1

* Tue May 11 1999 Bill Nottingham <notting@redhat.com>
- make it play nice with xsane, add ld.so.conf entries

* Wed Apr 21 1999 Bill Nottingham <notting@redhat.com>
- update to 1.0.1

* Tue Oct 13 1998 Michael Maher <mike@redhat.com>
- updated package

* Thu May 21 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 0.73

* Tue Jan 27 1998 Otto Hammersmith <otto@redhat.com>
- umax drivers were missing from the file list.

* Sun Dec  7 1997 Otto Hammersmith <otto@redhat.com>
- added wmconfig
- fixed library problem

* Tue Dec  2 1997 Otto Hammersmith <otto@redhat.com>
- added changelog
- got newer package from Sane web site than our old powertools one
